#!/usr/bin/env node
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var old_cli_config_1 = require("./old-cli-config");
var generate_and_save_1 = require("./generate-and-save");
var cli_error_1 = require("./utils/cli-error");
var fs_1 = require("fs");
var path_1 = require("path");
var yml_1 = require("./yml");
var ymlPath = path_1.join(process.cwd(), './codegen.yml');
var jsonPath = path_1.join(process.cwd(), './codegen.json');
var config;
if (fs_1.existsSync(ymlPath)) {
    config = yml_1.parseConfigFile(fs_1.readFileSync(ymlPath, 'utf-8'));
}
else if (fs_1.existsSync(jsonPath)) {
    config = JSON.parse(fs_1.readFileSync(jsonPath, 'utf-8'));
}
else {
    config = old_cli_config_1.createConfigFromOldCli(old_cli_config_1.initCLI(process.argv));
}
generate_and_save_1.generate(config)
    .then(function () { })
    .catch(cli_error_1.cliError);
//# sourceMappingURL=cli.js.map