"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var graphql_tools_1 = require("graphql-tools");
var helpers_1 = require("./helpers");
var introspection_from_url_1 = require("./loaders/schema/introspection-from-url");
var introspection_from_file_1 = require("./loaders/schema/introspection-from-file");
var schema_from_typedefs_1 = require("./loaders/schema/schema-from-typedefs");
var schema_from_export_1 = require("./loaders/schema/schema-from-export");
var documents_glob_1 = require("./utils/documents-glob");
var document_loader_1 = require("./loaders/documents/document-loader");
var validate_documents_1 = require("./loaders/documents/validate-documents");
var schemaHandlers = [
    new introspection_from_url_1.IntrospectionFromUrlLoader(),
    new introspection_from_file_1.IntrospectionFromFileLoader(),
    new schema_from_typedefs_1.SchemaFromTypedefs(),
    new schema_from_export_1.SchemaFromExport()
];
var loadSchema = function (schemaDef, config) { return __awaiter(_this, void 0, void 0, function () {
    var _i, schemaHandlers_1, handler, pointToSchema, options;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                _i = 0, schemaHandlers_1 = schemaHandlers;
                _a.label = 1;
            case 1:
                if (!(_i < schemaHandlers_1.length)) return [3 /*break*/, 4];
                handler = schemaHandlers_1[_i];
                pointToSchema = null;
                options = {};
                if (typeof schemaDef === 'string') {
                    pointToSchema = schemaDef;
                }
                else if (typeof schemaDef === 'object') {
                    pointToSchema = Object.keys(schemaDef)[0];
                    options = schemaDef[pointToSchema];
                }
                return [4 /*yield*/, handler.canHandle(pointToSchema)];
            case 2:
                if (_a.sent()) {
                    return [2 /*return*/, handler.handle(pointToSchema, config, options)];
                }
                _a.label = 3;
            case 3:
                _i++;
                return [3 /*break*/, 1];
            case 4: throw new Error("Could not handle schema: " + schemaDef);
        }
    });
}); };
function mergeSchemas(schemas) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            if (schemas.length === 0) {
                return [2 /*return*/, null];
            }
            else if (schemas.length === 1) {
                return [2 /*return*/, schemas[0]];
            }
            else {
                return [2 /*return*/, graphql_tools_1.mergeSchemas({ schemas: schemas.filter(function (s) { return s; }) })];
            }
            return [2 /*return*/];
        });
    });
}
function executeCodegen(config) {
    return __awaiter(this, void 0, void 0, function () {
        var result, requireExtensions, rootConfig, schemas, documents, generates, _i, _a, filename, rootSchema, _b, rootDocuments, foundDocumentsPaths, errors, _c, _d, filename, outputConfig, outputFileTemplateConfig, outputSchema, outputDocuments, outputSpecificSchemas, _e, _f, _g, outputSpecificDocuments, foundDocumentsPaths, additionalDocs, errors, normalizedPluginsArray, output;
        return __generator(this, function (_h) {
            switch (_h.label) {
                case 0:
                    result = [];
                    requireExtensions = helpers_1.normalizeInstanceOrArray(config.require);
                    requireExtensions.forEach(function (mod) { return require(mod); });
                    rootConfig = config.config || {};
                    schemas = helpers_1.normalizeInstanceOrArray(config.schema);
                    documents = helpers_1.normalizeInstanceOrArray(config.documents);
                    generates = {};
                    for (_i = 0, _a = Object.keys(config.generates); _i < _a.length; _i++) {
                        filename = _a[_i];
                        generates[filename] = helpers_1.normalizeOutputParam(config.generates[filename]);
                    }
                    _b = mergeSchemas;
                    return [4 /*yield*/, Promise.all(schemas.map(function (pointToScehma) { return loadSchema(pointToScehma, config); }))];
                case 1: return [4 /*yield*/, _b.apply(void 0, [_h.sent()])];
                case 2:
                    rootSchema = _h.sent();
                    rootDocuments = [];
                    if (!(documents.length > 0)) return [3 /*break*/, 5];
                    return [4 /*yield*/, documents_glob_1.documentsFromGlobs(documents)];
                case 3:
                    foundDocumentsPaths = _h.sent();
                    return [4 /*yield*/, document_loader_1.loadDocumentsSources(foundDocumentsPaths)];
                case 4:
                    rootDocuments = _h.sent();
                    if (rootSchema) {
                        errors = validate_documents_1.validateGraphQlDocuments(rootSchema, rootDocuments);
                        validate_documents_1.checkValidationErrors(errors, !config.watch);
                    }
                    _h.label = 5;
                case 5:
                    _c = 0, _d = Object.keys(generates);
                    _h.label = 6;
                case 6:
                    if (!(_c < _d.length)) return [3 /*break*/, 15];
                    filename = _d[_c];
                    outputConfig = generates[filename];
                    outputFileTemplateConfig = outputConfig.config || {};
                    outputSchema = rootSchema;
                    outputDocuments = rootDocuments;
                    outputSpecificSchemas = helpers_1.normalizeInstanceOrArray(outputConfig.schema);
                    if (!(outputSpecificSchemas.length > 0)) return [3 /*break*/, 9];
                    _e = mergeSchemas;
                    _g = (_f = [
                        rootSchema
                    ]).concat;
                    return [4 /*yield*/, Promise.all(outputSpecificSchemas.map(function (pointToScehma) { return loadSchema(pointToScehma, config); }))];
                case 7: return [4 /*yield*/, _e.apply(void 0, [_g.apply(_f, [(_h.sent())])])];
                case 8:
                    outputSchema = _h.sent();
                    _h.label = 9;
                case 9:
                    outputSpecificDocuments = helpers_1.normalizeInstanceOrArray(outputConfig.documents);
                    if (!(outputSpecificDocuments.length > 0)) return [3 /*break*/, 12];
                    return [4 /*yield*/, documents_glob_1.documentsFromGlobs(outputSpecificDocuments)];
                case 10:
                    foundDocumentsPaths = _h.sent();
                    return [4 /*yield*/, document_loader_1.loadDocumentsSources(foundDocumentsPaths)];
                case 11:
                    additionalDocs = _h.sent();
                    if (outputSchema) {
                        errors = validate_documents_1.validateGraphQlDocuments(outputSchema, additionalDocs);
                        validate_documents_1.checkValidationErrors(errors, !config.watch);
                    }
                    outputDocuments = rootDocuments.concat(additionalDocs);
                    _h.label = 12;
                case 12:
                    normalizedPluginsArray = helpers_1.normalizeConfig(outputConfig.plugins);
                    return [4 /*yield*/, generateOutput({
                            filename: filename,
                            plugins: normalizedPluginsArray,
                            schema: outputSchema,
                            documents: outputDocuments,
                            inheritedConfig: __assign({}, rootConfig, outputFileTemplateConfig)
                        })];
                case 13:
                    output = _h.sent();
                    result.push(output);
                    _h.label = 14;
                case 14:
                    _c++;
                    return [3 /*break*/, 6];
                case 15: return [2 /*return*/, result];
            }
        });
    });
}
exports.executeCodegen = executeCodegen;
function generateOutput(options) {
    return __awaiter(this, void 0, void 0, function () {
        var output, _i, _a, plugin, name_1, pluginConfig, result;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    output = '';
                    _i = 0, _a = options.plugins;
                    _b.label = 1;
                case 1:
                    if (!(_i < _a.length)) return [3 /*break*/, 4];
                    plugin = _a[_i];
                    name_1 = Object.keys(plugin)[0];
                    pluginConfig = plugin[name_1];
                    return [4 /*yield*/, executePlugin({
                            name: name_1,
                            config: typeof pluginConfig !== 'object'
                                ? pluginConfig
                                : __assign({}, options.inheritedConfig, pluginConfig),
                            schema: options.schema,
                            documents: options.documents
                        })];
                case 2:
                    result = _b.sent();
                    output += result;
                    _b.label = 3;
                case 3:
                    _i++;
                    return [3 /*break*/, 1];
                case 4: return [2 /*return*/, { filename: options.filename, content: output.trim() }];
            }
        });
    });
}
exports.generateOutput = generateOutput;
function getPluginByName(name) {
    return __awaiter(this, void 0, void 0, function () {
        var possibleNames, _i, possibleNames_1, packageName;
        return __generator(this, function (_a) {
            possibleNames = [
                "graphql-codegen-" + name,
                "graphql-codegen-" + name + "-template",
                "codegen-" + name,
                "codegen-" + name + "-template",
                name
            ];
            for (_i = 0, possibleNames_1 = possibleNames; _i < possibleNames_1.length; _i++) {
                packageName = possibleNames_1[_i];
                try {
                    return [2 /*return*/, require(packageName)];
                }
                catch (e) { }
            }
            throw new Error("Unable to find template plugin matching " + name + "!");
        });
    });
}
exports.getPluginByName = getPluginByName;
function executePlugin(options) {
    return __awaiter(this, void 0, void 0, function () {
        var pluginPackage;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, getPluginByName(options.name)];
                case 1:
                    pluginPackage = _a.sent();
                    return [2 /*return*/, pluginPackage.plugin(options.schema, options.documents, options.config)];
            }
        });
    });
}
exports.executePlugin = executePlugin;
//# sourceMappingURL=codegen.js.map